Lists all possible permutations. [:running:] [:vhs:] [:package:] [:moon:] [:ledger:]
> Similar: [permutation], [permutations], [isPermutation].<br>
> This is part of package [extra-array].

[extra-array]: https://www.npmjs.com/package/extra-array

```javascript
array.permutations(x, [n]);
// x: an array
// n: number of values (-1 => any)
```

```javascript
const array = require('extra-array');

[...array.permutations([1, 2])];
// [ [], [ 1 ], [ 2 ], [ 1, 2 ], [ 2, 1 ] ]

[...array.permutations([1, 2, 3])];
// [
//   [],          [ 1 ],
//   [ 2 ],       [ 3 ],
//   [ 1, 2 ],    [ 1, 3 ],
//   [ 2, 1 ],    [ 2, 3 ],
//   [ 3, 1 ],    [ 3, 2 ],
//   [ 1, 2, 3 ], [ 1, 3, 2 ],
//   [ 2, 1, 3 ], [ 2, 3, 1 ],
//   [ 3, 1, 2 ], [ 3, 2, 1 ]
// ]

[...array.permutations([1, 2, 3], 2)];
// [ [ 1, 2 ], [ 1, 3 ], [ 2, 1 ], [ 2, 3 ], [ 3, 1 ], [ 3, 2 ] ]
```

### references

- [Data.List.permutations: Haskell](https://hackage.haskell.org/package/base-4.12.0.0/docs/Data-List.html#v:permutations)

[:running:]: https://npm.runkit.com/@extra-array/permutations
[:package:]: https://www.npmjs.com/package/@extra-array/permutations
[:moon:]: https://www.npmjs.com/package/@extra-array/permutations.min
[permutation]: https://github.com/nodef/extra-array/wiki/permutation
[permutations]: https://github.com/nodef/extra-array/wiki/permutations
[isPermutation]: https://github.com/nodef/extra-array/wiki/isPermutation
[:ledger:]: https://unpkg.com/@extra-array/permutations/
[:vhs:]: https://asciinema.org/a/332961
